class Pile:
	"""
	Une classe qui implémente une pile. 
	1 attribut : 
		p		List qui contient les valeurs de la pile.
	4 méthodes : 
		contructeur 	Créer une pile vide.
		empiler(val) 	Empiler la valeur val en haut de la pile.
		depiler() 	Dépiler la valeur en haut de la pile et la renvoie.
		est_vide()  	Renvoie True si la pile est vide, False sinon.
	
	Pour afficher la pile, afficher l'attribut p print(nomVariable.p) ou décommenter la méthode qui suit et utiliser directement print(nomVariable). 
	def __str__(self):
		return self.p
	"""
	def __init__(self):
		self.p = list()
	
	def empiler(self, val):
		""" Ajoute une valeur en haut de la pile"""
		self.p.append(val)
		
	def depiler(self):
		""" Retire une valeur en haut de la pile et la retourne """
		return self.p.pop()
		
	def est_vide(self):
		""" Renvoie True si la pile est vide"""
		return len(self.p) == 0 


### Exercice test 
# 1. Créer une pile vide nommé w
w = Pile()
print("w est vide ? :", w.est_vide())
# 2. Ajouter 2, 4 puis 6 dans la pile
w.empiler(2)
print(w.p)
w.empiler(4)
print(w.p)
w.empiler(6)
print(w.p)
# 3. Enlever le 6 de la pile
v = w.depiler()
print(w.p)
print(v)
print("w est vide ? :", w.est_vide())
# 4. Ajouter 3 valeurs dans la pile
w.empiler(7)
w.empiler(9)
w.empiler(11)
print(w.p)
# 5. Inverser les valeurs dans la pile
x = Pile()
print("Début:\n w", w.p, "\n x", x.p)
while not w.est_vide():
	a = w.depiler()
	x.empiler(a)
	
print("Fin:\n w", w.p, "\n x", x.p)
# 6. Question supplémentaire : 
# Ecrire une fonction qui prend une pile en paramètre. 
# Elle devra retirer toutes les valeurs paires d'une pile et les renvoient sous la forme d'une pile,
# dans le même ordre que la pile donnée en paramètre. 



